;CodeVisionAVR C Compiler V1.24.7d Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90S8515
;Clock frequency        : 4.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90S8515
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R24,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "plan_STR.vec"
	.INCLUDE "plan_STR.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.23.7a Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2002 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 11/6/2009
;      12 Author  :                                 
;      13 Company :                                 
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : AT90S8515
;      18 Clock frequency     : 4.000000 MHz
;      19 Memory model        : Small
;      20 Internal SRAM size  : 512
;      21 External SRAM size  : 0
;      22 Data Stack size     : 128
;      23 *********************************************/
;      24 
;      25 #include <90s8515.h>
;      26 #define NRPROC 0x04
;      27 #define N 	10
;      28 #define WAIT_CIFRA 	500
;      29 
;      30 // stari
;      31 #define ST_0 0x00
;      32 #define ST_1 0x01
;      33 #define ST_2 0x02
;      34 #define ST_3 0x03
;      35 #define ST_4 0x04
;      36 #define ST_5 0x05
;      37 #define ST_6 0x06
;      38 #define ST_7 0x07
;      39 #define ST_8 0x08
;      40 #define ST_9 0x09
;      41 #define ST_10 0x0a
;      42 #define ST_11 0x0b
;      43 #define ST_12 0x0c
;      44 #define ST_13 0x0d
;      45 #define ST_14 0x0e
;      46 #define ST_15 0x0f
;      47 #define ST_16 0x10
;      48 #define ST_17 0x11
;      49 #define ST_18 0x12
;      50 #define ST_19 0x13
;      51 
;      52 void init_plan(void);
;      53 void Install(unsigned char new_st);
;      54 void SetTimer(unsigned int new_time);
;      55 char TimeOut(void);
;      56 void p_write(unsigned char *padd, unsigned char pdat);
;      57 //unsigned char p_read(unsigned char *padd);
;      58 
;      59 void st_0(void);
;      60 void st_1(void);
;      61 void st_2(void);
;      62 void st_3(void);
;      63 void st_4(void);
;      64 void st_5(void);
;      65 void st_6(void);
;      66 void st_7(void);
;      67 void st_8(void);
;      68 void st_9(void);
;      69 void st_10(void);
;      70 void st_11(void);
;      71 void st_12(void);
;      72 void st_13(void);
;      73 void st_14(void);
;      74 void st_15(void);
;      75 void st_16(void);
;      76 void st_17(void);
;      77 void st_18(void);
;      78 void st_19(void);
;      79 
;      80 // Declare your global variables here
;      81 
;      82 unsigned char crt_pid;//procesul curent
;      83 unsigned int timer[NRPROC];//tablou de timeri asociati proceselor
_timer:
	.BYTE 0x8
;      84 unsigned char CRT_ST[NRPROC];//starea curenta a proceselor
_CRT_ST:
	.BYTE 0x4
;      85 
;      86 char contor[NRPROC];
_contor:
	.BYTE 0x4
;      87 char contor1[NRPROC];
_contor1:
	.BYTE 0x4
;      88 char cnt[NRPROC];
_cnt:
	.BYTE 0x4
;      89 char cifra[NRPROC][2];
_cifra:
	.BYTE 0x8
;      90 char nr[NRPROC];
_nr:
	.BYTE 0x4
;      91 char apel[NRPROC];
_apel:
	.BYTE 0x4
;      92 
;      93 
;      94 //pointeri la functiile de stare ale proceselor
;      95 void (*p_func[])(void) = {
_p_func:
;      96 			 st_0,//0x00
;      97 			 st_1,//0x01
;      98 			 st_2,//0x02
;      99 			 st_3,//0x03
;     100 			 st_4,//0x04
;     101 			 st_5, //0x05
;     102 			 st_6,//0x06
;     103 			 st_7,//0x07
;     104 			 st_8,//0x08
;     105 			 st_9,//0x09
;     106 			 st_10,//0x0a
;     107 			 st_11,//0x0b
;     108 			 st_12,//0x0c
;     109 			 st_13,//0x0d
;     110 			 st_14,//0x0e
;     111 			 st_15,//0x0f
;     112 			 st_16,//0x10
;     113 			 st_17,//0x11 
;     114 			 st_18,//0x12
;     115 			 st_19 //0x13
;     116     			 };
	.BYTE 0x28
;     117 
;     118 void main(void)
;     119 {

	.CSEG
_main:
;     120 // Declare your local variables here
;     121 
;     122 // Input/Output Ports initialization
;     123 // Port A initialization
;     124 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     125 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     126 PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;     127 DDRA=0x00;
	OUT  0x1A,R30
;     128 
;     129 // Port B initialization
;     130 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;     131 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;     132 PORTB=0xFF;
	RCALL SUBOPT_0x0
;     133 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     134 
;     135 // Port C initialization
;     136 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     137 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;     138 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     139 DDRC=0x00;
	OUT  0x14,R30
;     140 
;     141 // Port D initialization
;     142 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;     143 // State0=P State1=P State2=P State3=P State4=P State5=P State6=P State7=P 
;     144 PORTD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x12,R30
;     145 DDRD=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
;     146 
;     147 // Timer/Counter 0 initialization
;     148 // Clock source: System Clock
;     149 // Clock value: 3.906 kHz
;     150 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     151 TCNT0=0x4E;
	RCALL SUBOPT_0x1
;     152 
;     153 // Timer/Counter 1 initialization
;     154 // Clock source: System Clock
;     155 // Clock value: Timer 1 Stopped
;     156 // Mode: Normal top=FFFFh
;     157 // OC1A output: Discon.
;     158 // OC1B output: Discon.
;     159 // Noise Canceler: Off
;     160 // Input Capture on Falling Edge
;     161 TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
;     162 TCCR1B=0x00;
	OUT  0x2E,R30
;     163 TCNT1H=0x00;
	OUT  0x2D,R30
;     164 TCNT1L=0x00;
	OUT  0x2C,R30
;     165 OCR1AH=0x00;
	OUT  0x2B,R30
;     166 OCR1AL=0x00;
	OUT  0x2A,R30
;     167 OCR1BH=0x00;
	OUT  0x29,R30
;     168 OCR1BL=0x00;
	OUT  0x28,R30
;     169 
;     170 // External Interrupt(s) initialization
;     171 // INT0: Off
;     172 // INT1: Off
;     173 GIMSK=0x00;
	OUT  0x3B,R30
;     174 MCUCR=0x00;
	OUT  0x35,R30
;     175 
;     176 // Timer(s)/Counter(s) Interrupt(s) initialization
;     177 TIMSK=0x02;
	LDI  R30,LOW(2)
	OUT  0x39,R30
;     178 
;     179 // Analog Comparator initialization
;     180 // Analog Comparator: Off
;     181 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     182 // Analog Comparator Output: Off
;     183 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     184 
;     185 // Global enable interrupts
;     186 #asm("sei")
	sei
;     187 
;     188 init_plan();
	RCALL _init_plan
;     189 PORTB=0xff;
	RCALL SUBOPT_0x0
;     190 
;     191 
;     192 while (1)
_0x4:
;     193       {
;     194       // Place your code here
;     195 
;     196       };
	RJMP _0x4
;     197 }
_0x7:
	RJMP _0x7
;     198 
;     199 // functii
;     200 
;     201 //locatia de la adresa adresa+crt_pid ia valoarea val
;     202 void PutXVal(unsigned char *adresa, unsigned char val)
;     203 {                
_PutXVal:
;     204 	p_write(adresa+crt_pid,val);
	MOV  R30,R4
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x2
	RCALL _p_write
;     205 }
	RJMP _0x2F
;     206 
;     207 //intoarce valoarea locatiei de la adresa adresa+crt_pid 
;     208 /*
;     209 unsigned char GetXVal(unsigned char *adresa)
;     210 {
;     211 	return(p_read(adresa+crt_pid));
;     212 }
;     213 */
;     214 
;     215 //scrie in portul de adresa padd valoarea pdat               
;     216 void p_write(unsigned char *padd, unsigned char pdat)
;     217 {
_p_write:
;     218 	  *padd=pdat;
	LD   R30,Y
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ST   X,R30
;     219 }
_0x2F:
	ADIW R28,3
	RET
;     220 
;     221 //citeste portul de adresa padd
;     222 /*
;     223 unsigned char p_read(unsigned char *padd) 
;     224 {
;     225 	  return(*padd);
;     226 }
;     227 */
;     228 // initializeaza starea initiala a proceselor
;     229 void init_plan()
;     230 {
_init_plan:
;     231 	for(crt_pid=0; crt_pid<NRPROC; crt_pid++)
	CLR  R4
_0x9:
	RCALL SUBOPT_0x3
	BRSH _0xA
;     232 	{
;     233 	apel[crt_pid]=0xff;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
;     234 // apel[crt_pid]=0xff - abonat liber
;     235 // apel[crt_pid]=20 - apel in desfasurare
;     236 // apel[crt_pid]= 1x pt. chemat ( x este abonatul chemator)
;     237 // apel[crt_pid]= y pt. chemator ( y este abonatul chemat)
;     238 	cnt[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
;     239 	contor[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     240 	contor1[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
;     241 	SetTimer(0);
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x9
;     242 	cifra[crt_pid][0]=0;
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xB
;     243 	cifra[crt_pid][1]=0;
	RCALL SUBOPT_0xA
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,1
	LDI  R30,LOW(0)
	ST   X,R30
;     244 	Install(ST_0);
	RCALL SUBOPT_0xC
;     245 	}
	INC  R4
	RJMP _0x9
_0xA:
;     246 }
	RET
;     247 
;     248 // instalare in alta stare a procesului crt_pid
;     249 void Install(unsigned char new_st)
;     250 {
_Install:
;     251 	PutXVal(CRT_ST, new_st);
	LDI  R30,LOW(_CRT_ST)
	LDI  R31,HIGH(_CRT_ST)
	RCALL SUBOPT_0x2
	RCALL _PutXVal
;     252 }
	ADIW R28,1
	RET
;     253 
;     254 
;     255 //incarca valoarea new_time in timerul procesului curent
;     256 void SetTimer(unsigned int new_time)
;     257 {
_SetTimer:
;     258 	timer[crt_pid]=new_time;
	RCALL SUBOPT_0xD
	ADD  R30,R26
	ADC  R31,R27
	LD   R26,Y
	LDD  R27,Y+1
	STD  Z+0,R26
	STD  Z+1,R27
;     259 }
	ADIW R28,2
	RET
;     260 
;     261 // intoarce 1 daca timerul procesului curenta ajuns la 0
;     262 char TimeOut()
;     263 {
_TimeOut:
;     264 	if(!(timer[crt_pid])) return(1);
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	BRNE _0xB
	LDI  R30,LOW(1)
	RET
;     265 	else return(0);
_0xB:
	LDI  R30,LOW(0)
	RET
;     266 }
	RET
;     267 
;     268 //stari
;     269 
;     270 void st_0 (void)
;     271 {
_st_0:
;     272 //cerere abonat Bi = 0
;     273 char tmp;
;     274 tmp = (PIND>>(2*crt_pid))&0x01;
	RCALL SUBOPT_0xF
;	tmp -> R16
;     275 if (tmp==0) Install(ST_1);
	CPI  R16,0
	BRNE _0xD
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x10
;     276 // abonat chemat
;     277 if (apel[crt_pid]!=0xff & tmp==0) Install(ST_17);
_0xD:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	MOV  R26,R16
	LDI  R30,LOW(0)
	RCALL __EQB12
	AND  R30,R0
	BREQ _0xE
	LDI  R30,LOW(17)
	RCALL SUBOPT_0x10
;     278 }
_0xE:
	RJMP _0x2E
;     279 
;     280 void st_1 (void)
;     281 {
_st_1:
;     282 //cerere abonat Bi = 1
;     283 char tmp;
;     284 tmp = (PIND>>(2*crt_pid))&0x01;
	RCALL SUBOPT_0xF
;	tmp -> R16
;     285 if (tmp==1) 	{
	CPI  R16,1
	BRNE _0xF
;     286 		tmp=~(1<<(2*crt_pid));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
;     287 		PORTB=PORTB&tmp; // Li - 0 
;     288 		SetTimer(WAIT_CIFRA);
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x9
;     289 // semnalizare apel in desfasurare
;     290 		apel[crt_pid]=20;
	RCALL SUBOPT_0x4
	SUBI R26,LOW(-_apel)
	SBCI R27,HIGH(-_apel)
	LDI  R30,LOW(20)
	RCALL SUBOPT_0x16
;     291 		Install(ST_2);
;     292 		}
;     293 }
_0xF:
	RJMP _0x2E
;     294 
;     295 void st_2 (void)            
;     296 {                     
_st_2:
;     297 //asteapta formarea cifrelor numarului abonatului chemat
;     298 char tmp;
;     299 // numar complet format              
;     300 if (TimeOut()) 
	ST   -Y,R16
;	tmp -> R16
	RCALL _TimeOut
	CPI  R30,0
	BREQ _0x10
;     301 		{
;     302 		tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     303 		PORTB=PORTB|tmp; // Li - 1
;     304 		Install(ST_0);
	RCALL SUBOPT_0xC
;     305                 }
;     306 if (cnt[crt_pid]==2) 	{   
_0x10:
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-_cnt)
	SBCI R31,HIGH(-_cnt)
	LD   R30,Z
	CPI  R30,LOW(0x2)
	BRNE _0x11
;     307 		cnt[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x6
;     308 		Install(ST_7);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x10
;     309 			}
;     310 tmp = (PIND>>(2*crt_pid))&0x3;
_0x11:
	RCALL SUBOPT_0x18
	ANDI R30,LOW(0x3)
	MOV  R16,R30
;     311 // apasat Bi (LSB)
;     312 if (tmp==2) Install(ST_3);
	CPI  R16,2
	BRNE _0x12
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x10
;     313 // apasat B2i (MSB)
;     314 if (tmp==1) Install(ST_4);
_0x12:
	CPI  R16,1
	BRNE _0x13
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x10
;     315 }
_0x13:
	RJMP _0x2E
;     316 
;     317 void st_3 (void)
;     318 {       
_st_3:
;     319 //asteapta Bi = 1
;     320 char tmp;
;     321 tmp = (PIND>>(2*crt_pid))&0x01;
	RCALL SUBOPT_0xF
;	tmp -> R16
;     322 if (tmp==1) Install(ST_5);
	CPI  R16,1
	BRNE _0x14
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x10
;     323 }
_0x14:
	RJMP _0x2E
;     324 
;     325 void st_4 (void)
;     326 {        
_st_4:
;     327 //asteapta B2i = 1
;     328 char tmp;
;     329 tmp = (PIND>>(2*crt_pid))&0x02;
	ST   -Y,R16
;	tmp -> R16
	RCALL SUBOPT_0x18
	ANDI R30,LOW(0x2)
	MOV  R16,R30
;     330 if (tmp==2) Install(ST_6);
	CPI  R16,2
	BRNE _0x15
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x10
;     331 }      
_0x15:
	RJMP _0x2E
;     332 
;     333 void st_5 (void)
;     334 {        
_st_5:
;     335 // Bi - puls 0->1             
;     336 char tmp;
;     337 tmp=cnt[crt_pid];
	RCALL SUBOPT_0x19
;	tmp -> R16
	RCALL SUBOPT_0x1A
;     338 cifra[crt_pid][tmp]=0;
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0xB
;     339 cnt[crt_pid]++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x1C
;     340 Install(ST_2);
;     341 }
	RJMP _0x2E
;     342 
;     343 void st_6 (void)
;     344 {
_st_6:
;     345 // B2i - puls 0->1             
;     346 char tmp;
;     347 tmp=cnt[crt_pid];
	RCALL SUBOPT_0x19
;	tmp -> R16
	RCALL SUBOPT_0x1A
;     348 cifra[crt_pid][tmp]=1;
	RCALL SUBOPT_0x1B
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1D
;     349 cnt[crt_pid]++;
	RCALL SUBOPT_0x1C
;     350 Install(ST_2);
;     351 }
	RJMP _0x2E
;     352 
;     353 void st_7 (void)
;     354 {         
_st_7:
;     355 // calculeza numarul abonatului chemat
;     356 // cerere catre abonatul chemat      
;     357 nr[crt_pid]=2*cifra[crt_pid][0]+cifra[crt_pid][1];
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-_nr)
	SBCI R31,HIGH(-_nr)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xA
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	LSL  R30
	MOV  R0,R30
	RCALL SUBOPT_0xA
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+1
	ADD  R30,R0
	POP  R26
	POP  R27
	RCALL SUBOPT_0x1E
;     358 if ( apel[nr[crt_pid]]==0xff )// abonat liber
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x12
	CPI  R30,LOW(0xFF)
	BRNE _0x16
;     359 	{
;     360 	apel[nr[crt_pid]]=crt_pid+10;
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	MOV  R30,R4
	SUBI R30,-LOW(10)
	ST   X,R30
;     361 	Install(ST_8);
	LDI  R30,LOW(8)
	RJMP _0x30
;     362 	}
;     363 else                          // abonat ocupat
_0x16:
;     364 	{
;     365 	Install(ST_13);
	LDI  R30,LOW(13)
_0x30:
	ST   -Y,R30
	RCALL _Install
;     366 	}                                     
;     367 if (nr[crt_pid]==crt_pid) Install(ST_13); // abonat chemat identic cu abonat cemator
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x21
	CP   R4,R30
	BRNE _0x18
	RCALL SUBOPT_0x22
;     368 }
_0x18:
	RET
;     369 
;     370 void st_8 (void)
;     371 {                              
_st_8:
;     372 //apel sonerie la abonatul chemat
;     373 char tmp;
;     374 // renuntare la apel
;     375 tmp = (PIND>>(2*crt_pid))&0x01;
	RCALL SUBOPT_0xF
;	tmp -> R16
;     376 if (tmp==0) Install(ST_18);
	CPI  R16,0
	BRNE _0x19
	LDI  R30,LOW(18)
	RCALL SUBOPT_0x10
;     377 //abonatul chemat a raspuns
;     378 // si abonatul chemat nu are un apel in desfasurare
;     379 if ((apel[crt_pid]!=0xff)&(apel[crt_pid]!=20))
_0x19:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	MOV  R1,R30
	RCALL SUBOPT_0x13
	MOV  R30,R1
	LDI  R26,LOW(20)
	RCALL __NEB12
	AND  R30,R0
	BREQ _0x1A
;     380  Install(ST_11);
	RCALL SUBOPT_0x23
;     381 
;     382 tmp=~(1<<(2*nr[crt_pid]));
_0x1A:
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x15
;     383 PORTB=PORTB&tmp; // Lnr = 0       
;     384 contor[crt_pid]++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x25
;     385 if (contor[crt_pid]==N) {
	RCALL SUBOPT_0x26
	BRNE _0x1B
;     386 			contor[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     387 			Install(ST_9);
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x10
;     388 			}           
;     389 }
_0x1B:
	RJMP _0x2E
;     390 
;     391 void st_9 (void)
;     392 {        
_st_9:
;     393 //apel sonerie la abonatul chemat
;     394 char tmp;
;     395 tmp=(1<<(2*nr[crt_pid]));
	RCALL SUBOPT_0x19
;	tmp -> R16
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x17
;     396 PORTB=PORTB|tmp;   // Lnr = 1    
;     397 contor[crt_pid]++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x25
;     398 if (contor[crt_pid]==N) {
	RCALL SUBOPT_0x26
	BRNE _0x1C
;     399 			contor[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x7
;     400 			Install(ST_8);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x10
;     401 			}
;     402 }
_0x1C:
	RJMP _0x2E
;     403 
;     404 void st_10 (void)
;     405 {        
_st_10:
;     406 //raspuns la apel                           
;     407 char tmp;
;     408 tmp=~(1<<(2*crt_pid));
	RCALL SUBOPT_0x27
;	tmp -> R16
	RCALL SUBOPT_0x15
;     409 PORTB=PORTB&tmp;  // Li = 0      
;     410 tmp = apel[crt_pid]-10;
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	SUBI R30,LOW(10)
	MOV  R16,R30
;     411 apel[tmp]=crt_pid;
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_apel)
	SBCI R27,HIGH(-_apel)
	ST   X,R4
;     412 Install(ST_11);
	RCALL SUBOPT_0x23
;     413 }      
	RJMP _0x2E
;     414 
;     415 void st_11 (void)
;     416 {             
_st_11:
;     417 //convorbire 
;     418 char tmp;
;     419 tmp = (PIND>>(2*crt_pid))&0x01;
	RCALL SUBOPT_0xF
;	tmp -> R16
;     420 if (tmp==0) Install(ST_12); // Bi = 0 
	CPI  R16,0
	BRNE _0x1D
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x10
;     421 }
_0x1D:
	RJMP _0x2E
;     422 
;     423 void st_12 (void)
;     424 {           
_st_12:
;     425 //incheiere convorbire de catre abonatul chemator ( apel <9)             
;     426 char tmp;
;     427 tmp = (PIND>>(2*crt_pid))&0x01;                    
	RCALL SUBOPT_0xF
;	tmp -> R16
;     428 if ((tmp==1)&&(apel[crt_pid]==0xff)) // abonatul chemat                       
	CPI  R16,1
	BRNE _0x1F
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	CPI  R30,LOW(0xFF)
	BREQ _0x20
_0x1F:
	RJMP _0x1E
_0x20:
;     429 	{
;     430 	tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     431 	PORTB=PORTB|tmp; // Li = 1       
;     432 	Install(ST_0);
	RCALL SUBOPT_0xC
;     433 	}
;     434 if ((tmp==1)&&(apel[crt_pid]<9)) // abonatul chemator
_0x1E:
	CPI  R16,1
	BRNE _0x22
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	CPI  R30,LOW(0x9)
	BRLO _0x23
_0x22:
	RJMP _0x21
_0x23:
;     435 	{
;     436 	tmp=apel[crt_pid];     // inchide comunicatia
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-_apel)
	SBCI R31,HIGH(-_apel)
	LD   R16,Z
;     437 	apel[crt_pid]=-1;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
;     438 	apel[tmp]=-1;
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x5
;     439 	tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     440 	PORTB=PORTB|tmp; // Li = 1       
;     441 	Install(ST_0);
	RCALL SUBOPT_0xC
;     442 	}
;     443 }
_0x21:
	RJMP _0x2E
;     444 
;     445 void st_13 (void)
;     446 {                                                           
_st_13:
;     447 //ocupat
;     448 char tmp;
;     449 tmp=~(1<<(2*crt_pid));
	RCALL SUBOPT_0x27
;	tmp -> R16
	RCALL SUBOPT_0x15
;     450 PORTB=PORTB&tmp; // Li = 0      
;     451 contor1[crt_pid]++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x29
;     452 if (contor1[crt_pid]==N) {
	RCALL SUBOPT_0x2A
	BRNE _0x24
;     453 			contor1[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
;     454 			Install(ST_14);
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x10
;     455 			}           
;     456 tmp = (PIND>>(2*crt_pid))&0x01;  //Bi = 0
_0x24:
	RCALL SUBOPT_0x18
	ANDI R30,LOW(0x1)
	MOV  R16,R30
;     457 if (tmp==0) Install(ST_15);
	CPI  R16,0
	BRNE _0x25
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x10
;     458 }
_0x25:
	RJMP _0x2E
;     459 
;     460 void st_14 (void)
;     461 { 
_st_14:
;     462 //ocupat
;     463 char tmp;
;     464 tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x27
;	tmp -> R16
	RCALL SUBOPT_0x17
;     465 PORTB=PORTB|tmp;  //Li = 1     
;     466 contor1[crt_pid]++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x29
;     467 if (contor1[crt_pid]==N) {
	RCALL SUBOPT_0x2A
	BRNE _0x26
;     468 			contor1[crt_pid]=0;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
;     469 			Install(ST_13);
	RCALL SUBOPT_0x22
;     470 			}
;     471 }
_0x26:
	RJMP _0x2E
;     472 
;     473 void st_15 (void)
;     474 {       
_st_15:
;     475 // incheiere daca a fost ocupat
;     476 char tmp;
;     477 tmp = (PIND>>(2*crt_pid))&0x01; //Bi = 1
	RCALL SUBOPT_0xF
;	tmp -> R16
;     478 if (tmp==1) Install(ST_16);
	CPI  R16,1
	BRNE _0x27
	LDI  R30,LOW(16)
	RCALL SUBOPT_0x10
;     479 }
_0x27:
	RJMP _0x2E
;     480 
;     481 void st_16 (void)
;     482 {
_st_16:
;     483 // incheiere daca a fost ocupat
;     484 char tmp;
;     485 tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x27
;	tmp -> R16
	RCALL SUBOPT_0x17
;     486 PORTB=PORTB|tmp;  //Li = 1     
;     487 Install(ST_0);
	RCALL SUBOPT_0xC
;     488 }      
	RJMP _0x2E
;     489 
;     490 void st_17 (void)
;     491 {
_st_17:
;     492 char tmp;
;     493 tmp = (PIND>>(2*crt_pid))&0x01; // Bi = 1
	RCALL SUBOPT_0xF
;	tmp -> R16
;     494 if (tmp==1) Install(ST_10);
	CPI  R16,1
	BRNE _0x28
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x10
;     495 }      
_0x28:
	RJMP _0x2E
;     496                                             
;     497 void st_18 (void)
;     498 {
_st_18:
;     499 char tmp;
;     500 tmp = (PIND>>(2*crt_pid))&0x01; // Bi = 1
	RCALL SUBOPT_0xF
;	tmp -> R16
;     501 if (tmp==1) Install(ST_19);
	CPI  R16,1
	BRNE _0x29
	LDI  R30,LOW(19)
	RCALL SUBOPT_0x10
;     502 }      
_0x29:
	RJMP _0x2E
;     503                         
;     504 void st_19 (void)
;     505 {
_st_19:
;     506 char tmp;
;     507 apel[nr[crt_pid]]=0xff;
	RCALL SUBOPT_0x19
;	tmp -> R16
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x1D
;     508 apel[crt_pid]=0xff;
	RCALL SUBOPT_0x5
;     509 tmp=(1<<(2*crt_pid));
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     510 PORTB=PORTB|tmp; // Li = 1       
;     511 tmp=(1<<(2*nr[crt_pid]));
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x17
;     512 PORTB=PORTB|tmp; // Lnr = 1       
;     513 Install(ST_0);
	RCALL SUBOPT_0xC
;     514 }      
_0x2E:
	LD   R16,Y+
	RET
;     515 
;     516 
;     517 
;     518 // interrupt
;     519 
;     520 // Timer 0 overflow interrupt service routine
;     521 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     522 {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     523 // Reinitialize Timer 0 value
;     524 TCNT0=0x4E;
	RCALL SUBOPT_0x1
;     525 // Place your code here
;     526 for(crt_pid=0; crt_pid < NRPROC; crt_pid++)
	CLR  R4
_0x2B:
	RCALL SUBOPT_0x3
	BRSH _0x2C
;     527 {
;     528 // decrementeaza timerii
;     529 if(timer[crt_pid]) timer[crt_pid]--;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	BREQ _0x2D
	RCALL SUBOPT_0xD
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
;     530 //executa procesul crt_pid
;     531 (*p_func[CRT_ST[crt_pid]])();
_0x2D:
	RCALL SUBOPT_0x11
	SUBI R30,LOW(-_CRT_ST)
	SBCI R31,HIGH(-_CRT_ST)
	LD   R30,Z
	LDI  R26,LOW(_p_func)
	LDI  R27,HIGH(_p_func)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	ICALL
;     532 }    
	INC  R4
	RJMP _0x2B
_0x2C:
;     533 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI


;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(255)
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(78)
	OUT  0x32,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(4)
	CP   R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x4:
	MOV  R26,R4
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5:
	SUBI R26,LOW(-_apel)
	SBCI R27,HIGH(-_apel)
	LDI  R30,LOW(255)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	SUBI R26,LOW(-_cnt)
	SBCI R27,HIGH(-_cnt)
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7:
	SUBI R26,LOW(-_contor)
	SBCI R27,HIGH(-_contor)
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x8:
	SUBI R26,LOW(-_contor1)
	SBCI R27,HIGH(-_contor1)
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _SetTimer

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xA:
	MOV  R30,R4
	LDI  R26,LOW(_cifra)
	LDI  R27,HIGH(_cifra)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RJMP _Install

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xD:
	MOV  R30,R4
	LDI  R26,LOW(_timer)
	LDI  R27,HIGH(_timer)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0xF:
	ST   -Y,R16
	IN   R30,0x10
	MOV  R26,R30
	MOV  R30,R4
	LSL  R30
	RCALL __LSRB12
	ANDI R30,LOW(0x1)
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 23 TIMES
SUBOPT_0x10:
	ST   -Y,R30
	RJMP _Install

;OPTIMIZER ADDED SUBROUTINE, CALLED 22 TIMES
SUBOPT_0x11:
	MOV  R30,R4
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x12:
	SUBI R30,LOW(-_apel)
	SBCI R31,HIGH(-_apel)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDI  R26,LOW(255)
	RCALL __NEB12
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x14:
	MOV  R30,R4
	LSL  R30
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x15:
	COM  R30
	MOV  R16,R30
	IN   R30,0x18
	AND  R30,R16
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x16:
	ST   X,R30
	LDI  R30,LOW(2)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x17:
	MOV  R16,R30
	IN   R30,0x18
	OR   R30,R16
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x18:
	IN   R30,0x10
	MOV  R26,R30
	MOV  R30,R4
	LSL  R30
	RCALL __LSRB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x19:
	ST   -Y,R16
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	SUBI R30,LOW(-_cnt)
	SBCI R31,HIGH(-_cnt)
	LD   R16,Z
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	SUBI R26,LOW(-_cnt)
	SBCI R27,HIGH(-_cnt)
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1D:
	ST   X,R30
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1E:
	ST   X,R30
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	SUBI R30,LOW(-_nr)
	SBCI R31,HIGH(-_nr)
	LD   R30,Z
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	SUBI R30,LOW(-_apel)
	SBCI R31,HIGH(-_apel)
	MOV  R26,R30
	MOV  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x21:
	SUBI R30,LOW(-_nr)
	SBCI R31,HIGH(-_nr)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	LDI  R30,LOW(13)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	LDI  R30,LOW(11)
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	LSL  R30
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	SUBI R26,LOW(-_contor)
	SBCI R27,HIGH(-_contor)
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	SUBI R30,LOW(-_contor)
	SBCI R31,HIGH(-_contor)
	LD   R30,Z
	CPI  R30,LOW(0xA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x27:
	ST   -Y,R16
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	MOV  R26,R16
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x29:
	SUBI R26,LOW(-_contor1)
	SBCI R27,HIGH(-_contor1)
	LD   R30,X
	SUBI R30,-LOW(1)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	SUBI R30,LOW(-_contor1)
	SBCI R31,HIGH(-_contor1)
	LD   R30,Z
	CPI  R30,LOW(0xA)
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__NEB12:
	CP   R30,R26
	LDI  R30,1
	BRNE __NEB12T
	CLR  R30
__NEB12T:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

;END OF CODE MARKER
__END_OF_CODE:
