/*********************************************
This program was produced by the
CodeWizardAVR V1.23.7a Professional
Automatic Program Generator
 Copyright 1998-2002 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 11/6/2009
Author  :                                 
Company :                                 
Comments: 


Chip type           : AT90S8515
Clock frequency     : 4.000000 MHz
Memory model        : Small
Internal SRAM size  : 512
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <90s8515.h>
#define NRPROC 0x04
#define N 	10
#define WAIT_CIFRA 	500

// stari
#define ST_0 0x00
#define ST_1 0x01
#define ST_2 0x02
#define ST_3 0x03
#define ST_4 0x04
#define ST_5 0x05
#define ST_6 0x06
#define ST_7 0x07
#define ST_8 0x08
#define ST_9 0x09
#define ST_10 0x0a
#define ST_11 0x0b
#define ST_12 0x0c
#define ST_13 0x0d
#define ST_14 0x0e
#define ST_15 0x0f
#define ST_16 0x10
#define ST_17 0x11
#define ST_18 0x12
#define ST_19 0x13

void init_plan(void);
void Install(unsigned char new_st);
void SetTimer(unsigned int new_time);
char TimeOut(void);
void p_write(unsigned char *padd, unsigned char pdat);
//unsigned char p_read(unsigned char *padd);

void st_0(void);
void st_1(void);
void st_2(void);
void st_3(void);
void st_4(void);
void st_5(void);
void st_6(void);
void st_7(void);
void st_8(void);
void st_9(void);
void st_10(void);
void st_11(void);
void st_12(void);
void st_13(void);
void st_14(void);
void st_15(void);
void st_16(void);
void st_17(void);
void st_18(void);
void st_19(void);

// Declare your global variables here

unsigned char crt_pid;//procesul curent
unsigned int timer[NRPROC];//tablou de timeri asociati proceselor
unsigned char CRT_ST[NRPROC];//starea curenta a proceselor

char contor[NRPROC];
char contor1[NRPROC];
char cnt[NRPROC];
char cifra[NRPROC][2];
char nr[NRPROC];
char apel[NRPROC];


//pointeri la functiile de stare ale proceselor
void (*p_func[])(void) = {
			 st_0,//0x00
			 st_1,//0x01
			 st_2,//0x02
			 st_3,//0x03
			 st_4,//0x04
			 st_5, //0x05
			 st_6,//0x06
			 st_7,//0x07
			 st_8,//0x08
			 st_9,//0x09
			 st_10,//0x0a
			 st_11,//0x0b
			 st_12,//0x0c
			 st_13,//0x0d
			 st_14,//0x0e
			 st_15,//0x0f
			 st_16,//0x10
			 st_17,//0x11 
			 st_18,//0x12
			 st_19 //0x13
    			 };

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
// State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
PORTB=0xFF;
DDRB=0xFF;

// Port C initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
// State0=P State1=P State2=P State3=P State4=P State5=P State6=P State7=P 
PORTD=0xFF;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 3.906 kHz
TCCR0=0x05;
TCNT0=0x4E;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;

// Global enable interrupts
#asm("sei")

init_plan();
PORTB=0xff;


while (1)
      {
      // Place your code here

      };
}

// functii

//locatia de la adresa adresa+crt_pid ia valoarea val
void PutXVal(unsigned char *adresa, unsigned char val)
{                
	p_write(adresa+crt_pid,val);
}

//intoarce valoarea locatiei de la adresa adresa+crt_pid 
/*
unsigned char GetXVal(unsigned char *adresa)
{
	return(p_read(adresa+crt_pid));
}
*/

//scrie in portul de adresa padd valoarea pdat               
void p_write(unsigned char *padd, unsigned char pdat)
{
	  *padd=pdat;
}

//citeste portul de adresa padd
/*
unsigned char p_read(unsigned char *padd) 
{
	  return(*padd);
}
*/
// initializeaza starea initiala a proceselor
void init_plan()
{
	for(crt_pid=0; crt_pid<NRPROC; crt_pid++)
	{
	apel[crt_pid]=0xff;
// apel[crt_pid]=0xff - abonat liber
// apel[crt_pid]=20 - apel in desfasurare
// apel[crt_pid]= 1x pt. chemat ( x este abonatul chemator)
// apel[crt_pid]= y pt. chemator ( y este abonatul chemat)
	cnt[crt_pid]=0;
	contor[crt_pid]=0;
	contor1[crt_pid]=0;
	SetTimer(0);
	cifra[crt_pid][0]=0;
	cifra[crt_pid][1]=0;
	Install(ST_0);
	}
}

// instalare in alta stare a procesului crt_pid
void Install(unsigned char new_st)
{
	PutXVal(CRT_ST, new_st);
}


//incarca valoarea new_time in timerul procesului curent
void SetTimer(unsigned int new_time)
{
	timer[crt_pid]=new_time;
}

// intoarce 1 daca timerul procesului curenta ajuns la 0
char TimeOut()
{
	if(!(timer[crt_pid])) return(1);
	else return(0);
}

//stari

void st_0 (void)
{
//cerere abonat Bi = 0
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01;
if (tmp==0) Install(ST_1);
// abonat chemat
if (apel[crt_pid]!=0xff & tmp==0) Install(ST_17);
}

void st_1 (void)
{
//cerere abonat Bi = 1
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01;
if (tmp==1) 	{
		tmp=~(1<<(2*crt_pid));
		PORTB=PORTB&tmp; // Li - 0 
		SetTimer(WAIT_CIFRA);
// semnalizare apel in desfasurare
		apel[crt_pid]=20;
		Install(ST_2);
		}
}

void st_2 (void)            
{                     
//asteapta formarea cifrelor numarului abonatului chemat
char tmp;
// numar complet format              
if (TimeOut()) 
		{
		tmp=(1<<(2*crt_pid));
		PORTB=PORTB|tmp; // Li - 1
		Install(ST_0);
                }
if (cnt[crt_pid]==2) 	{   
		cnt[crt_pid]=0;
		Install(ST_7);
			}
tmp = (PIND>>(2*crt_pid))&0x3;
// apasat Bi (LSB)
if (tmp==2) Install(ST_3);
// apasat B2i (MSB)
if (tmp==1) Install(ST_4);
}

void st_3 (void)
{       
//asteapta Bi = 1
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01;
if (tmp==1) Install(ST_5);
}

void st_4 (void)
{        
//asteapta B2i = 1
char tmp;
tmp = (PIND>>(2*crt_pid))&0x02;
if (tmp==2) Install(ST_6);
}      

void st_5 (void)
{        
// Bi - puls 0->1             
char tmp;
tmp=cnt[crt_pid];
cifra[crt_pid][tmp]=0;
cnt[crt_pid]++;
Install(ST_2);
}

void st_6 (void)
{
// B2i - puls 0->1             
char tmp;
tmp=cnt[crt_pid];
cifra[crt_pid][tmp]=1;
cnt[crt_pid]++;
Install(ST_2);
}

void st_7 (void)
{         
// calculeza numarul abonatului chemat
// cerere catre abonatul chemat      
nr[crt_pid]=2*cifra[crt_pid][0]+cifra[crt_pid][1];
if ( apel[nr[crt_pid]]==0xff )// abonat liber
	{
	apel[nr[crt_pid]]=crt_pid+10;
	Install(ST_8);
	}
else                          // abonat ocupat
	{
	Install(ST_13);
	}                                     
if (nr[crt_pid]==crt_pid) Install(ST_13); // abonat chemat identic cu abonat cemator
}

void st_8 (void)
{                              
//apel sonerie la abonatul chemat
char tmp;
// renuntare la apel
tmp = (PIND>>(2*crt_pid))&0x01;
if (tmp==0) Install(ST_18);
//abonatul chemat a raspuns
// si abonatul chemat nu are un apel in desfasurare
if ((apel[crt_pid]!=0xff)&(apel[crt_pid]!=20))
 Install(ST_11);

tmp=~(1<<(2*nr[crt_pid]));
PORTB=PORTB&tmp; // Lnr = 0       
contor[crt_pid]++;
if (contor[crt_pid]==N) {
			contor[crt_pid]=0;
			Install(ST_9);
			}           
}

void st_9 (void)
{        
//apel sonerie la abonatul chemat
char tmp;
tmp=(1<<(2*nr[crt_pid]));
PORTB=PORTB|tmp;   // Lnr = 1    
contor[crt_pid]++;
if (contor[crt_pid]==N) {
			contor[crt_pid]=0;
			Install(ST_8);
			}
}

void st_10 (void)
{        
//raspuns la apel                           
char tmp;
tmp=~(1<<(2*crt_pid));
PORTB=PORTB&tmp;  // Li = 0      
tmp = apel[crt_pid]-10;
apel[tmp]=crt_pid;
Install(ST_11);
}      

void st_11 (void)
{             
//convorbire 
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01;
if (tmp==0) Install(ST_12); // Bi = 0 
}

void st_12 (void)
{           
//incheiere convorbire de catre abonatul chemator ( apel <9)             
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01;                    
if ((tmp==1)&&(apel[crt_pid]==0xff)) // abonatul chemat                       
	{
	tmp=(1<<(2*crt_pid));
	PORTB=PORTB|tmp; // Li = 1       
	Install(ST_0);
	}
if ((tmp==1)&&(apel[crt_pid]<9)) // abonatul chemator
	{
	tmp=apel[crt_pid];     // inchide comunicatia
	apel[crt_pid]=-1;
	apel[tmp]=-1;
	tmp=(1<<(2*crt_pid));
	PORTB=PORTB|tmp; // Li = 1       
	Install(ST_0);
	}
}

void st_13 (void)
{                                                           
//ocupat
char tmp;
tmp=~(1<<(2*crt_pid));
PORTB=PORTB&tmp; // Li = 0      
contor1[crt_pid]++;
if (contor1[crt_pid]==N) {
			contor1[crt_pid]=0;
			Install(ST_14);
			}           
tmp = (PIND>>(2*crt_pid))&0x01;  //Bi = 0
if (tmp==0) Install(ST_15);
}

void st_14 (void)
{ 
//ocupat
char tmp;
tmp=(1<<(2*crt_pid));
PORTB=PORTB|tmp;  //Li = 1     
contor1[crt_pid]++;
if (contor1[crt_pid]==N) {
			contor1[crt_pid]=0;
			Install(ST_13);
			}
}

void st_15 (void)
{       
// incheiere daca a fost ocupat
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01; //Bi = 1
if (tmp==1) Install(ST_16);
}

void st_16 (void)
{
// incheiere daca a fost ocupat
char tmp;
tmp=(1<<(2*crt_pid));
PORTB=PORTB|tmp;  //Li = 1     
Install(ST_0);
}      

void st_17 (void)
{
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01; // Bi = 1
if (tmp==1) Install(ST_10);
}      
                                            
void st_18 (void)
{
char tmp;
tmp = (PIND>>(2*crt_pid))&0x01; // Bi = 1
if (tmp==1) Install(ST_19);
}      
                        
void st_19 (void)
{
char tmp;
apel[nr[crt_pid]]=0xff;
apel[crt_pid]=0xff;
tmp=(1<<(2*crt_pid));
PORTB=PORTB|tmp; // Li = 1       
tmp=(1<<(2*nr[crt_pid]));
PORTB=PORTB|tmp; // Lnr = 1       
Install(ST_0);
}      



// interrupt

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x4E;
// Place your code here
for(crt_pid=0; crt_pid < NRPROC; crt_pid++)
{
// decrementeaza timerii
if(timer[crt_pid]) timer[crt_pid]--;
//executa procesul crt_pid
(*p_func[CRT_ST[crt_pid]])();
}    
}
